library("nor1mix")
#library("flexmix")
library("GoFKernel")
library("goftest")
library("dbEmpLikeGOF")
library(kedd)


rm(list = ls())

"kde"<-function(xin, xout, h, kfun)
{
  n<- length(xin)
  arg1<-(sapply(xout, "-", xin))/h  
  arg2<-kfun(arg1)
  arg3<-colSums(arg2)
  arg3/(n*h)
}


getPval<-function (testcall, teststat, x, y, vrb = TRUE) 
{
  if ((testcall == "normal") | (testcall == "uniform")) {
    if (testcall == "uniform") {
      testmat <- unifCut
    }
    if (testcall == "normal") {
      testmat <- normCut
    }
    smp.size <- length(x)
    coldx <- which(colnames(testmat) == smp.size)
    if (length(coldx) > 0) {
      colvls <- testmat[, coldx]
      difvls <- colvls - teststat
      absvls <- abs(difvls)
      matchVl <- which(absvls == 0)
      if (length(matchVl > 0)) {
        pvl <- as.numeric(rownames(testmat)[matchVl])
      }
      else {
        rowdx <- which(absvls == min(absvls))
        pvl <- helperPval(rowdx, colvls, teststat, testmat)
      }
    }
    else {
      if ((smp.size < 10) | (smp.size > 10000)) {
        if (smp.size < 10) {
          cat("Table generated on sample size between 10 and 10000. \n Estimating based on sample size of 10 \n For more accurate calculation use monte carlo method [pvl.Table=FALSE] \n")
          coldx <- 1
          colvls <- testmat[, coldx]
          difvls <- colvls - teststat
          absvls <- abs(difvls)
          matchVl <- which(absvls == 0)
          if (length(matchVl > 0)) {
            pvl <- as.numeric(rownames(testmat)[matchVl])
          }
          else {
            rowdx <- which(absvls == min(absvls))
            pvl <- helperPval(rowdx, colvls, teststat, 
                              testmat)
          }
        }
        else {
          cat("Table generated on sample size between 10 and 10000. \n Estimating based on sample size of 10000 \n For more accurate calculation use monte carlo method [pvl.Table=FALSE] \n")
          coldx <- 13
          colvls <- testmat[, coldx]
          difvls <- colvls - teststat
          absvls <- abs(difvls)
          matchVl <- which(absvls == 0)
          if (length(matchVl > 0)) {
            pvl <- as.numeric(rownames(testmat)[matchVl])
          }
          else {
            rowdx <- which(absvls == min(absvls))
            pvl <- helperPval(rowdx, colvls, teststat, 
                              testmat)
          }
        }
      }
      else {
        coldx1 <- max(which(as.numeric(colnames(testmat)) < 
                              smp.size))
        coldx2 <- min(which(as.numeric(colnames(testmat)) > 
                              smp.size))
        colvls <- testmat[, coldx1]
        difvls <- colvls - teststat
        absvls <- abs(difvls)
        matchVl <- which(absvls == 0)
        if (length(matchVl > 0)) {
          pvl1 <- as.numeric(rownames(testmat)[matchVl])
        }
        else {
          rowdx <- which(absvls == min(absvls))
          pvl1 <- helperPval(rowdx, colvls, teststat, 
                             testmat)
        }
        colvls <- testmat[, coldx2]
        difvls <- colvls - teststat
        absvls <- abs(difvls)
        matchVl <- which(absvls == 0)
        if (length(matchVl > 0)) {
          pvl2 <- as.numeric(rownames(testmat)[matchVl])
        }
        else {
          rowdx <- which(absvls == min(absvls))
          pvl2 <- helperPval(rowdx, colvls, teststat, 
                             testmat)
        }
        tempx <- c(as.numeric(colnames(testmat)[coldx1]), 
                   as.numeric(colnames(testmat)[coldx2]))
        tempy <- c(pvl1, pvl2)
        datamat <- as.data.frame(cbind(tempx, tempy))
        modelest <- lm("tempy~tempx", data = datamat)
        pvl <- as.numeric(modelest$coefficients[1]) + 
          (smp.size * as.numeric(modelest$coefficients[2]))
      }
    }
  }
  else {
    testmat <- distEqCut
    smp.size <- length(x)
    coldx <- which(colnames(testmat) == smp.size)
    if (length(coldx) > 0) {
      colvls <- testmat[, coldx]
      difvls <- colvls - teststat
      absvls <- abs(difvls)
      matchVl <- which(absvls == 0)
      if (length(matchVl > 0)) {
        pvlx <- as.numeric(rownames(testmat)[matchVl])
      }
      else {
        rowdx <- which(absvls == min(absvls))
        pvlx <- helperPval(rowdx, colvls, teststat, testmat)
      }
    }
    else {
      if ((smp.size < 10) | (smp.size > 500)) {
        if (smp.size < 10) {
          cat("Table generated on sample size between 10 and 500. \n Estimating based on sample size of 10 \n For more accurate calculation use monte carlo method [pvl.Table=FALSE] \n")
          coldx <- 1
          colvls <- testmat[, coldx]
          difvls <- colvls - teststat
          absvls <- abs(difvls)
          matchVl <- which(absvls == 0)
          if (length(matchVl > 0)) {
            pvl <- as.numeric(rownames(testmat)[matchVl])
          }
          else {
            rowdx <- which(absvls == min(absvls))
            pvl <- helperPval(rowdx, colvls, teststat, 
                              testmat)
          }
        }
        else {
          cat("Table generated on sample size between 10 and 500. \n Estimating based on sample size of 500 \n For more accurate calculation use monte carlo method [pvl.Table=FALSE] \n")
          coldx <- 8
          colvls <- testmat[, coldx]
          difvls <- colvls - teststat
          absvls <- abs(difvls)
          matchVl <- which(absvls == 0)
          if (length(matchVl > 0)) {
            pvl <- as.numeric(rownames(testmat)[matchVl])
          }
          else {
            rowdx <- which(absvls == min(absvls))
            pvl <- helperPval(rowdx, colvls, teststat, 
                              testmat)
          }
        }
      }
      else {
        coldx1 <- max(which(as.numeric(colnames(testmat)) < 
                              smp.size))
        coldx2 <- min(which(as.numeric(colnames(testmat)) > 
                              smp.size))
        colvls <- testmat[, coldx1]
        difvls <- colvls - teststat
        absvls <- abs(difvls)
        matchVl <- which(absvls == 0)
        if (length(matchVl > 0)) {
          pvl1 <- as.numeric(rownames(testmat)[matchVl])
        }
        else {
          rowdx <- which(absvls == min(absvls))
          pvl1 <- helperPval(rowdx, colvls, teststat, 
                             testmat)
        }
        colvls <- testmat[, coldx2]
        difvls <- colvls - teststat
        absvls <- abs(difvls)
        matchVl <- which(absvls == 0)
        if (length(matchVl > 0)) {
          pvl2 <- as.numeric(rownames(testmat)[matchVl])
        }
        else {
          rowdx <- which(absvls == min(absvls))
          pvl2 <- helperPval(rowdx, colvls, teststat, 
                             testmat)
        }
        tempx <- c(as.numeric(colnames(testmat)[coldx1]), 
                   as.numeric(colnames(testmat)[coldx2]))
        tempy <- c(pvl1, pvl2)
        datamat <- as.data.frame(cbind(tempx, tempy))
        modelest <- lm("tempy~tempx", data = datamat)
        pvlx <- as.numeric(modelest$coefficients[1]) + 
          (smp.size * as.numeric(modelest$coefficients[2]))
      }
    }
    if (length(y) == length(x)) {
      pvl = pvlx
    }
    else {
      smp.size <- length(y)
      coldx <- which(colnames(testmat) == smp.size)
      if (length(coldx) > 0) {
        colvls <- testmat[, coldx]
        difvls <- colvls - teststat
        absvls <- abs(difvls)
        matchVl <- which(absvls == 0)
        if (length(matchVl > 0)) {
          pvly <- as.numeric(rownames(testmat)[matchVl])
        }
        else {
          rowdx <- which(absvls == min(absvls))
          pvly <- helperPval(rowdx, colvls, teststat, 
                             testmat)
        }
      }
      else {
        if ((smp.size < 10) | (smp.size > 500)) {
          if (smp.size < 10) {
            cat("Table generated on sample size between 10 and 500. \n Estimating based on sample size of 10 \n For more accurate calculation use monte carlo method [pvl.Table=FALSE] \n")
            coldx <- 1
            colvls <- testmat[, coldx]
            difvls <- colvls - teststat
            absvls <- abs(difvls)
            matchVl <- which(absvls == 0)
            if (length(matchVl > 0)) {
              pvl <- as.numeric(rownames(testmat)[matchVl])
            }
            else {
              rowdx <- which(absvls == min(absvls))
              pvl <- helperPval(rowdx, colvls, teststat, 
                                testmat)
            }
          }
          else {
            cat("Table generated on sample size between 10 and 500. \n Estimating based on sample size of 500 \n For more accurate calculation use monte carlo method [pvl.Table=FALSE] \n")
            coldx <- 8
            colvls <- testmat[, coldx]
            difvls <- colvls - teststat
            absvls <- abs(difvls)
            matchVl <- which(absvls == 0)
            if (length(matchVl > 0)) {
              pvl <- as.numeric(rownames(testmat)[matchVl])
            }
            else {
              rowdx <- which(absvls == min(absvls))
              pvl <- helperPval(rowdx, colvls, teststat, 
                                testmat)
            }
          }
        }
        else {
          coldx1 <- max(which(as.numeric(colnames(testmat)) < 
                                smp.size))
          coldx2 <- min(which(as.numeric(colnames(testmat)) > 
                                smp.size))
          colvls <- testmat[, coldx1]
          difvls <- colvls - teststat
          absvls <- abs(difvls)
          matchVl <- which(absvls == 0)
          if (length(matchVl > 0)) {
            pvl1 <- as.numeric(rownames(testmat)[matchVl])
          }
          else {
            rowdx <- which(absvls == min(absvls))
            pvl1 <- helperPval(rowdx, colvls, teststat, 
                               testmat)
          }
          colvls <- testmat[, coldx2]
          difvls <- colvls - teststat
          absvls <- abs(difvls)
          matchVl <- which(absvls == 0)
          if (length(matchVl > 0)) {
            pvl2 <- as.numeric(rownames(testmat)[matchVl])
          }
          else {
            rowdx <- which(absvls == min(absvls))
            pvl2 <- helperPval(rowdx, colvls, teststat, 
                               testmat)
          }
          tempx <- c(as.numeric(colnames(testmat)[coldx1]), 
                     as.numeric(colnames(testmat)[coldx2]))
          tempy <- c(pvl1, pvl2)
          datamat <- as.data.frame(cbind(tempx, tempy))
          modelest <- lm("tempy~tempx", data = datamat)
          pvly <- as.numeric(modelest$coefficients[1]) + 
            (smp.size * as.numeric(modelest$coefficients[2]))
        }
      }
      pvl <- mean(c(pvlx, pvly))
    }
  }
  return(pvl)
}
dbEmpLikeGOF<-function (x, y = NA, testcall = c("uniform", "normal"), delta = 0.5, 
                        delta.equality = 0.1, num.mc = 1000, pvl.Table = TRUE, vrb = TRUE, 
                        random.seed.flag = TRUE) 
{
  if (is.na(y[1])) {
    if ((testcall != "uniform") & (testcall != "normal")) {
      stop("testcall not appropriately defined in function call \n  testcall should be either 'uniform' or 'normal' \n")
    }
    else {
      nx <- length(x)
      if (testcall == "uniform") {
        if (vrb) 
          n <- length(x)
        x.o <- sort(x)
        m <- 1:n^(1 - delta)
        tomin <- mapply(FUN = "testfun", m = m, MoreArgs = list(x.o = x.o, 
                                                                n = n))
        logTomin <- log(tomin)
        sumTomin <- apply(FUN = "sum", MARGIN = 2, logTomin)
        teststat <- min(sumTomin)
        if (pvl.Table) {
          if (delta != 0.5) 
            cat("Table calculated on a delta = 0.5 \n    To use delta=", 
                delta, " please change pvl.Table to FALSE \n")
          pvl <- getPval(testcall, teststat, x, y, vrb)
        }
        else {
          if (vrb) 
            mc.est <- c()
          for (j in 1:num.mc) {
            if (random.seed.flag) {
              set.seed(j)
            }
            x <- runif(nx)
            x.o <- sort(x)
            m <- 1:nx^(1 - delta)
            tomin <- mapply(FUN = "testfun", m = m, MoreArgs = list(x.o = x.o, 
                                                                    n = nx))
            logTomin <- log(tomin)
            sumTomin <- apply(FUN = "sum", MARGIN = 2, 
                              logTomin)
            mc.est[j] <- min(sumTomin)
          }
          estp.rh <- sum(mc.est > teststat)/num.mc
          pvl <- estp.rh
        }
        output <- list(teststat = teststat, pvalue = pvl)
      }
      else {
        if (vrb) 
          n <- length(x)
        m1 <- 1:round(n/2)
        m2 <- 1:n^(1 - delta)
        x.o <- sort(x)
        VN2 <- mapply(FUN = "testfun", m = m2, MoreArgs = list(x.o = x.o, 
                                                               n = n))
        logVN2 <- log(VN2)
        sumVN2 <- apply(FUN = "sum", MARGIN = 2, logVN2)
        teststat <- min((((n/2) * log(2 * pi * exp(1) * 
                                        var(x))) + sumVN2))
        if (pvl.Table) {
          if (delta != 0.5) 
            cat("Table calculated on a delta = 0.5 \n    To use delta=", 
                delta, " please change pvl.Table to FALSE \n")
          pvl <- getPval(testcall, teststat, x, y, vrb)
        }
        else {
          if (vrb) 
            mc.estVN2 <- c()
          for (j in 1:num.mc) {
            if (random.seed.flag) {
              set.seed(j)
            }
            x <- rnorm(nx)
            m2 <- 1:nx^(1 - delta)
            x.o <- sort(x)
            VN2 <- mapply(FUN = "testfun", m = m2, MoreArgs = list(x.o = x.o, 
                                                                   n = nx))
            logVN2 <- log(VN2)
            sumVN2 <- apply(FUN = "sum", MARGIN = 2, 
                            logVN2)
            mc.estVN2[j] <- min((((n/2) * log(2 * pi * 
                                                exp(1) * var(x))) + sumVN2))
          }
          estp.rh <- sum(mc.estVN2 > teststat)/num.mc
          pvl <- estp.rh
        }
        output <- list(teststat = teststat, pvalue = pvl)
      }
    }
  }
  else {
    if ((delta.equality > 0.25) & (delta.equality < 0)) 
      stop("delta.equality must be between 0.0 and 0.25")
    testcall <- "distribution.equality"
    if (vrb) 
      n1 <- length(x)
    n2 <- length(y)
    l1 <- floor(n1^(0.5 + delta.equality))
    u1 <- ceiling(min((n1^(1 - delta.equality)), (n1/2)))
    mvc <- seq(l1, u1, by = 1)
    j1 <- 1:n1
    i <- 1
    tomin1 <- mapply(FUN = "testfun5", m = mvc, MoreArgs = list(x = x, 
                                                                y = y, i = i, j = j1))
    ans.pt1 <- min(tomin1)
    l2 <- floor(n2^(0.5 + delta.equality))
    u2 <- ceiling(min((n2^(1 - delta.equality)), (n2/2)))
    vvc <- seq(l2, u2, by = 1)
    j2 <- 1:n2
    i <- 2
    tomin2 <- mapply(FUN = "testfun5", m = vvc, MoreArgs = list(x = x, 
                                                                y = y, i = i, j = j2))
    ans.pt2 <- min(tomin2)
    teststat <- log((ans.pt1 * ans.pt2))
    if (pvl.Table) {
      if (delta.equality != 0.1) 
        cat("Table calculated on a delta = 0.1 \n    To use delta.equality=", 
            delta.equality, " please change pvl.Table to FALSE \n")
      pvl <- getPval(testcall, teststat, x, y, vrb)
    }
    else {
      if (vrb) 
        toMinpvec <- c()
      for (j in 1:num.mc) {
        if (random.seed.flag) {
          set.seed(j)
        }
        v1 <- rnorm(n1, mean = 0, sd = 1)
        if (random.seed.flag) {
          set.seed(j + 1)
        }
        v2 <- rnorm(n2, mean = 0, sd = 1)
        l1 <- floor(n1^(0.5 + delta.equality))
        u1 <- ceiling(min((n1^(1 - delta.equality)), 
                          (n1/2)))
        mvc <- seq(l1, u1, by = 1)
        j1 <- 1:n1
        i <- 1
        tomin1 <- mapply(FUN = "testfun5", m = mvc, MoreArgs = list(x = v1, 
                                                                    y = v2, i = i, j = j1))
        ans.pt1 <- min(tomin1)
        l2 <- floor(n2^(0.5 + delta.equality))
        u2 <- ceiling(min((n2^(1 - delta.equality)), 
                          (n2/2)))
        vvc <- seq(l2, u2, by = 1)
        j2 <- 1:n2
        i <- 2
        tomin2 <- mapply(FUN = "testfun5", m = vvc, MoreArgs = list(x = v1, 
                                                                    y = v2, i = i, j = j2))
        ans.pt2 <- min(tomin2)
        toMinpvec[j] <- log((ans.pt1 * ans.pt2))
      }
      estp.rh <- sum(toMinpvec > teststat)/num.mc
      pvl <- estp.rh
    }
    output <- list(teststat = teststat, pvalue = pvl)
  }
  return(output)
}


fan.test<-function (x, fun.den, par = NULL, lower = -Inf, upper = Inf,  kernel = "normal", bw = NULL) 
{
  data.name <- deparse(substitute(x))
  x <- c(na.omit(x))
  if (length(x) < 2) 
    stop("Not enough observations (at least after removing missing values)")
  if (!is.numeric(lower) || !is.numeric(upper) || lower >= 
      upper) 
    stop("lower < upper is not fulfilled")
  if (min(x) < lower || max(x) > upper) {
    output <- list(statistic = -Inf, p.value = 0, method = "Fan's test", 
                   kernel = kernel, data.name = data.name)
    warning("There is at least a sample value out of the theoretical support")
    return(output)
  }
  if (is.null(bw)) {
    h.min <- dpik(x, kernel = kernel)
  }
  else {
    h.min <- bw
  }
  f <- fun.den
  if (length(par) != 0) 
    f <- function(m) do.call(fun.den, c(list(m), par))
  n.x <- length(x)
  if (kernel == "normal") 
    nucleo <- dnorm
  if (kernel == "box") 
    nucleo <- function(x) ifelse(x >= -1 & x <= 1, 0.5, 0)
  if (kernel == "epanech") 
    nucleo <- function(x) ifelse(x >= -1 & x <= 1, (3/4) * 
                                   (1 - x^2), 0)
  if (!is.finite(f(lower))) 
    lower <- lower + h.min
  if (!is.finite(f(upper))) 
    upper <- upper - h.min
  samp1.no.diag <- matrix(nrow = 1, ncol = n.x)
  for (j in 1:n.x) samp1.no.diag[1, j] <- sum(nucleo((x - x[j])/h.min)) - 
    nucleo((x[j] - x[j])/h.min)
  primera.comp <- sum(samp1.no.diag, na.rm = TRUE)/(h.min * 
                                                      n.x * (n.x - 1))
  convolution <- function(y, v) (1/h.min) * nucleo((y - v)/h.min) * 
    f(v)
  int.conv <- function(y) sapply(y, function(v) integrate(convolution, 
                                                          lower = lower, upper = upper, v = v, rel.tol = 0.001)$value)
  fun.cuad <- function(y) {
    int.conv(y)^2
  }
  segunda.comp <- integrate(fun.cuad, lower = lower, upper = upper, 
                            rel.tol = 0.001, subdivisions = 100)$value
  tercera.comp <- (2/n.x) * sum(int.conv(x))
  Ign <- primera.comp + segunda.comp - tercera.comp
  samp1 <- matrix(nrow = 1, ncol = n.x)
  for (j in 1:n.x) {
    samp1[1, j] <- sum(nucleo((x - x[j])/h.min)^2)
  }
  sigma.cuadrado <- 2 * (1/(h.min * n.x^2)) * sum(samp1, na.rm = TRUE)
  est <- n.x * sqrt(h.min) * Ign/sqrt(sigma.cuadrado)
  p.value <- pnorm(est, lower.tail = FALSE)
  names(est) <- "Ig"
  output <- list(statistic = est, p.value = p.value, method = "Fan's test", 
                 kernel = kernel, data.name = data.name)
  class(output) <- "htest"
  return(output)
}

options(show.error.messages = FALSE)

kgaussian<-function(x)
{
  result <- 0.3989 * exp(-0.5*x*x)
  result
}

kunif<- function(x) { ifelse(abs(x)< 2.236068, (3/4)*(1-((x^2)/5 ))/2.236068, ifelse(abs(x)>2.236068, 0,0)) }


NormMixtProb<-function(x, n, p1)
{
  piuse1 <- pnorMix(x[1:(n+1)], p1) # calculate the pi's under the null
  piuse2 <- pnorMix(x[2:(n+2)], p1)
  piuse<- piuse2 - piuse1 #  p_j=\int_{I_i} f_0(x) dx = F_0(x_{i+1})-F_0(x_i)
  piusen<- 1-pnorMix(x[n+2], p1) # probbaility of the last (half) interval
  
  piuse<-c( piuse, piusen)
  piuse
}


ExpProb<-function(x, n, p1)
{
  piuse1 <- pexp(x[1:(n+1)], rate=p1) # calculate the pi's under the null
  piuse2 <- pexp(x[2:(n+2)], rate=p1)
  piuse<- piuse2 - piuse1 #  p_j=\int_{I_i} f_0(x) dx = F_0(x_{i+1})-F_0(x_i)
  piusen<- 1-pexp(x[n+2], rate=p1) # probbaility of the last (half) interval
  
  piuse<-c( piuse, piusen)
  piuse
}

LNProb<-function(x, n, p1, p2)
{
  piuse1 <- plnorm(x[1:(n+1)], meanlog=p1, sdlog = p2) # calculate the pi's under the null
  piuse2 <- plnorm(x[2:(n+2)], meanlog=p1, sdlog = p2)
  piuse<- piuse2 - piuse1 #  p_j=\int_{I_i} f_0(x) dx = F_0(x_{i+1})-F_0(x_i)
  piusen<- 1-plnorm(x[n+2], meanlog=p1, sdlog = p2) # probbaility of the last (half) interval
  
  piuse<-c( piuse, piusen)
  piuse
}

WeibProb<-function(x, n, p1, p2)
{
  piuse1 <- pweibull(x[1:(n+1)], p1, p2) # calculate the pi's under the null
  piuse2 <- pweibull(x[2:(n+2)], p1, p2)
  piuse<- piuse2 - piuse1 #  p_j=\int_{I_i} f_0(x) dx = F_0(x_{i+1})-F_0(x_i)
  piusen<- 1-pweibull(x[n+2], p1, p2) # probbaility of the last (half) interval
  
  piuse<-c( piuse, piusen)
  piuse
}

NormProb<-function(x, n, p1=0, p2=1)
{
  piuse1 <- pnorm(x[1:(n+1)], p1, p2) # calculate the pi's under the null
  piuse2 <- pnorm(x[2:(n+2)], p1, p2)
  piuse<- piuse2 - piuse1 #  p_j=\int_{I_i} f_0(x) dx = F_0(x_{i+1})-F_0(x_i)
  piusen<- 1-pnorm(x[n+2], p1, p2) # probbaility of the last (half) interval
  
  piuse<-c( piuse, piusen)
  piuse
}


NDistDens<-function(x, dist, p1, p2)
{
  switch(dist, 
         normixt = dnorMix(x,  p1), 
         exponential = dexp(x, p1),
         lnorm = dlnorm(x,  p1, p2), 
         weibull = dweibull(x, p1, p2),
         normal = dnorm(x, p1, p2)
  )
}

NDistProb<-function(x, dist, p1, p2)
{
  switch(dist, 
         normixt = pnorMix(x,  p1), 
         exponential = pexp(x, p1),
         lnorm = plnorm(x,  p1, p2), 
         weibull = pweibull(x, p1, p2),
         normal = pnorm(x, p1, p2)
  )
}


NDistQuant<-function(x, dist, p1, p2)
{
  switch(dist, 
         normixt = qnorMix(x,  p1), 
         exponential = qexp(x, p1),
         lnorm = qlnorm(x,  p1, p2), 
         weibull = qweibull(x, p1, p2),
         normal = qnorm(x, p1, p2)
  )
}


NDistChoice<-function(x, dist, n, p1, p2)
{
  switch(dist, 
         normixt = NormMixtProb(x, n, p1), 
         exponential = ExpProb(x, n, p1),
         lnorm = LNProb(x, n, p1, p2), 
         weibull = WeibProb(x, n, p1, p2),
         normal = NormProb(x, n, p1, p2))
}


DataDistribution<-function(SampleSize, Datadist,  s1, s2)
{
  switch(Datadist, 
         normixt = rnorMix(SampleSize, s1), 
         exponential = rexp(SampleSize, rate=s1),
         lnorm = rlnorm(SampleSize, meanlog=s1, sdlog = s2), 
         weibull = rweibull(SampleSize, s1, s2),
         normal = rnorm(SampleSize, s1, s2))
}

NDistDensSq<-function(x, dist, p1, p2)
{
  switch(dist, 
         normixt = dnorMix(x,  p1)^2, 
         exponential = dexp(x, p1)^2,
         lnorm = dlnorm(x,  p1, p2)^2, 
         weibull = dweibull(x, p1, p2)^2,
         normal = dnorm(x, p1, p2)^2
  )
}



int1 <- function(dist, p1, p2) 
{ 
  F1<-integrate(NDistDensSq, lower = -Inf, upper = Inf, dist, p1, p2)$value
  F1
} 


 

hopt.be<-function(xin)
{
  n<-length(xin)
  h<-bw.SJ(xin) #pilot bandwidth for the kernel estimate
  DensityEst <- kde(xin,xin, h, kunif)
  Rhatfx <- mean(DensityEst) #estimate R(f)
  Rhatfxthird <- mean(DensityEst^3) #estimate R(f)
  banduse<- (1/sqrt(n))*sqrt((Rhatfx * 0.2571)/(Rhatfxthird * 0.345)) #based on the epanechnikov kernel
  banduse
}


T.n2<-function(xin, h, dist, p1, p2)
  #xin: the random sample
  # h: the bandwidth to use in the test statistic - also conider the very first MSE optimal rule
  # dist: distribution under the null
  # p1: 1st parameter of the distribution dist. In case of Normal Mixtures this is the object MW.nm7 etc
  # p2: 2nd parameter of the distribution dist.
{
  MinX<-min(xin)
  MaxX<-max(xin)
  N<-length(xin)
  
  Delta<-1/N^{3/4} #n is the number of bins - set by A1.
  n<- ceiling( (MaxX - MinX)/Delta ) # Assumption A1: Delta ~ N^{-a}, 1/2<a<1, set a=3/4.  
  
  PartInt<-c(MinX, MinX+(1:n)*Delta) #Partion the interval (x[1], x[n]) into subintervals
  BinCenters<-( PartInt[1:n] + PartInt[2:(n+1)])/2 # calculate the Bincenters:
  
  yi <- sapply(1:n, function(i, xin, PartInt) length(which(xin >= PartInt[i] & xin < PartInt[i+1])), xin, PartInt)/(N*Delta) #scaled bin counts as p.d.f. estimates
  
  arg1<-(sapply(BinCenters, "-", BinCenters))  # cross product of all BinCenters in order to calculate K{(x_i - x_j)/h}
  Null.Dens.Est<- NDistDens(BinCenters, dist,   p1, p2)  
  
  Dens.Diffs<- yi-Null.Dens.Est  # Yi - f(x_i) 
  All.Dens.Diffs<- Dens.Diffs %*% t(Dens.Diffs)  # cross product of all Yi - f(x_i) diffs
  arg2<-kunif(arg1/h) #h
  test.stat.tmp<-arg2 * All.Dens.Diffs 
  
  test.statistic<-   sum(test.stat.tmp) 
  c(test.statistic, Delta) 
}


PowerGraphs<-function(SampleSize,  dist, Datadist,  p1, p2, altparam, h, a.sig)
{
  nn<-length(altparam)
  TBDmatrix<-matrix(0, nrow=nn, ncol=7)
  for(i in 1:nn)
  {
    PowerMat<-matrix(0,nrow=100, ncol=ncol(TBDmatrix)-1)
    band.mat.asympt<-matrix(0, nrow=100, ncol=1)
    for(j in 1:100)
    {
      x1<-DataDistribution(SampleSize, dist,  p1, p2) 
      x2<-DataDistribution(SampleSize, Datadist,  p2, p2) 
       
      h.use <- hopt.be(x1)
      x1 <- x1 +  h.use^{1/4} * altparam[i]/(sqrt(SampleSize) *SampleSize^{1/8})  *(x2-x1)*SampleSize^{1/4}
      a.tmp1<- T.n2(x1, h.use, dist, p1, p2)  
      a.tmp <- SampleSize * a.tmp1[2]^{2} * a.tmp1[1] * h.use^{- 1/2}
      a.tmp.1 <- a.tmp1[1] * h.use^{- 1/2}/SampleSize 
      
      in.val <- integrate(NDistDensSq, lower=-Inf, upper=Inf, dist=dist, p1=p1, p2=p2)$value
      band.mat.asympt[j,1] <- sqrt(2*3/5 * in.val ) *qnorm(1-a.sig)  
      fantest<-  fan.test(x1, NDistDens, par=list(dist, p1, p2), bw=dpik(x1)/4)$p.value #, lower=-3, upper=3, kernel="epanech"
      ADtest <- ad.test(x1, NDistProb,  dist, p1, p2)$p.value 
      CVMtest<- cvm.test(x1, NDistProb,  dist, p1, p2)$p.value
      
      y1<-DataDistribution(SampleSize, dist,  p1, p2) #need to change this
      LGoFtest<-  dbEmpLikeGOF(x1, y1)$pvalue

      PowerMat[j,]<- c(a.tmp, a.tmp.1, fantest,ADtest,CVMtest, LGoFtest) #store the test statistic values
    }	
    CutOffMat.asympt<-  band.mat.asympt[,1] 
    aps<-PowerMat[,1]
    aps1<-  PowerMat[,2]
    FanTestps<-PowerMat[,3]
    ADtestps<-PowerMat[,4]
    CVMtestps<-PowerMat[,5]
    LGoFtestps<-PowerMat[,6]
    
    apow.edgew <-length(which(aps1 > CutOffMat.asympt/7) )  #approximately equal (but x50 times faster) results with the bootstrap      
    apow.asympt<-length(which(aps > CutOffMat.asympt)) 
    FanTestPower<-length(which(FanTestps < a.sig))
    ADtestPower<-length(which(ADtestps < a.sig))
    CVMtestPower<- length(which(CVMtestps < a.sig))
    LGoFtestPower<- length(which(LGoFtestps < a.sig))
    
    TBDmatrix[i,]<-c(altparam[i], apow.edgew, apow.asympt, FanTestPower, ADtestPower, CVMtestPower, LGoFtestPower)	
  }
  colnames(TBDmatrix)<-c("Drift", "Sb", "Sa", "Fn", "An", "Cn", "Vn")
  TBDmatrix
}




Power.Simulation<-function(NIter, SampleSize, h, Datadist, dist,   p1, p2,altparam, a.sig)
{
  AllResults<-list(NIter)
  TestNames<-  c("Sn", "Fn", "An", "Cn", "Vn")
  TestNames1<- c(expression(S[n]), expression(F[n]), expression(A[n]) ,  expression(C[n]), expression(V[n]))
  for(i in 1:NIter)
  {
    cat("i= ", i, "\n")
    AllResults[[i]]<-PowerGraphs(SampleSize,  dist, Datadist,  p1, p2, altparam, h, a.sig)
    prmatrix(AllResults[[i]])
    }
  Result.Out<- Reduce("+", AllResults)/NIter # return average of NIter iterations
  Plot.Power(Result.Out, TestNames1, altparam)
  colnames(Result.Out)<-c("Pitman Drift", "Sb", "Sa", "Fn", "An", "Cn", "Vn")
  Result.Out
}

Plot.Power<-function(In.Matrix, TestNames1, altparam)
{
  n<-ncol(In.Matrix)
  matplot(In.Matrix[,1], In.Matrix[,2:n], type="l", lty = 1:(n-1), col=rep(1, times=n-1), xlab="Pitman Drift",    ylab="Power", ylim=c(0,100))
  legend("bottomright", c(expression(S[b]), expression(S[a]), expression(F[n]), expression(A[n]) ,  expression(C[n]), expression(V[n])), lty=1:(n-1), col=rep(1, times=n-1), merge=TRUE, ncol=2)
}

set.seed(4)

a.sig<-0.05
SampleSize<-40
Number.Iter<-60

Nulldist<-"normixt"

NullDistParam1<- MW.nm7  
NullDistParam2<- MW.nm15 
Altdist<-"normixt"


AltDistParam <-    seq(0, 2.1 , by=0.15) 
mya<-  Power.Simulation(Number.Iter, SampleSize, h, Nulldist, Altdist,  NullDistParam1, NullDistParam2, AltDistParam, a.sig) #PowerGraphs(SampleSize,  Nulldist, Altdist,  NullDistParam1, NullDistParam2, AltDistParam, h, a.sig=0.05)
write.csv(mya, file=paste(deparse(substitute(MW.nm7-nm15)), "Fig2d.csv"))

mya


