#library(readxl)
library(ggplot2)

#options(device=cairo_pdf)
rm(list = ls())
 
getwd()
Plot.Power<-function(In.Matrix)
{
  #plot.new()
  xout<-In.Matrix[,1]
  Power.Sb<-In.Matrix[,2]
  Power.Sa<-In.Matrix[,3] 
  Power.Jn<-In.Matrix[,4]
  Power.Fn<-In.Matrix[,5]
  Power.In<-In.Matrix[,6]
  Power.Vn<-In.Matrix[,7]
 cat(xout, "\n")
  #dev.off()
  
  mydat1<-data.frame(Power = Power.Sb, time= xout)
  mydat2<-data.frame(Power = Power.Sa, time= xout)
  mydat3<-data.frame(Power = Power.Jn, time= xout)
  mydat4<-data.frame(Power = Power.Fn, time= xout)
  mydat5<-data.frame(Power = Power.In, time= xout)
  mydat6<-data.frame(Power = Power.Vn, time= xout)
  
  mydat1<-data.frame(Power.Function = Power.Sb, Pitman.Drift= xout, Power.Est = rep("Sb", dim(mydat1)[1]))
  mydat2<-data.frame(Power.Function = Power.Sa, Pitman.Drift= xout, Power.Est = rep("Sa", dim(mydat2)[1]))
  mydat3<-data.frame(Power.Function = Power.Jn, Pitman.Drift= xout, Power.Est = rep("Jn", dim(mydat3)[1]))
  mydat4<-data.frame(Power.Function = Power.Fn, Pitman.Drift= xout, Power.Est = rep("Fn", dim(mydat4)[1]))
  mydat5<-data.frame(Power.Function = Power.In, Pitman.Drift= xout, Power.Est = rep("In", dim(mydat5)[1]))
  mydat6<-data.frame(Power.Function = Power.Vn, Pitman.Drift= xout, Power.Est = rep("Vn", dim(mydat6)[1]))
 
  mydat <- rbind(mydat1, mydat2, mydat3, mydat4, mydat5, mydat6)
 
  ggplot(data=mydat, aes(x=Pitman.Drift, y=Power.Function))+
    labs(  x = "KL distance", y = "Power Function")+
    geom_line(aes(color=Power.Est,  linetype=Power.Est, size=Power.Est)) +
    geom_line(data=mydat2, linetype = "dashed", color="blue") + 
    geom_line(data=mydat3, linetype = "twodash", color="red") + 
    geom_line(data=mydat4, linetype = "longdash", color="green") + 
    geom_line(data=mydat5, linetype = "dotdash", color="grey") + 
    geom_line(data=mydat6, linetype = "dotted", color="orange") + 
    scale_linetype_manual(values = c("Sb"="solid", "Sa"="dashed", "Jn"="twodash", "Fn"="longdash", "In"="dotdash", "Vn"="dotted"),
                          name="Power.Est", 
                          labels = c("Sb"="Snb", "Sa"="Sna", "Jn"="Jn", "Fn"="Fn", "In"="In", "Vn"="Vn"))+ 
    scale_size_manual(values = c("Sb" = 1.1, "Sa"=1.1, "Jn" = 1.1,  "Fn" = 1.1, "In" = 1.1, "Vn" = 1.1), 
                      name="Power.Est", 
                      labels = c("Sb"="Snb", "Sa"="Sna", "Jn"="Jn", "Fn"="Fn", "In"="In", "Vn"="Vn")) +
    scale_colour_manual(values = c("Snb"="black", "Sna"="blue", "Jn"="red", "Fn"="green", "In"="grey", "Vn"="orange"),
                        name="Power.Est", 
                        labels = c("Sb"="Snb", "Sa"="Sna",   "Jn"="Jn", "Fn"="Fn", "In"="In", "Vn"="Vn"))+ 
    theme(plot.title = element_text(lineheight=1),
          text = element_text(size=16),
          legend.title=element_blank(), #element_text(size=12),
          legend.title.align=0.5,
          legend.text = element_text(size=16),
          legend.position=c(0.98, 0.26),
          legend.justification = c(1, 1),
          legend.key.width = unit(2,'cm'),
          legend.key.height = unit(0.6, 'cm'),
          legend.box="horizontal") 
 # cairo_pdf(title, width=11.69, height=8.27) 
  #dev.off()
 #matplot(In.Matrix[,1], In.Matrix[,c(2,3,4,5,6)], type="l", lty = 1:(n-1), col=rep(1, times=n-1), lwd=rep(2, times=n-1), xlab="KL Divergence",  ylab="Power", ylim=c(0,100))
 #legend("bottomright", c(expression(S[n]),  expression(F[n]), expression(I[mn]),  expression(D[n]),  expression(V[n]) ), lty=1:(n-1), lwd=rep(2, times=n-1), col=rep(1, times=n-1), merge=TRUE, ncol=2)
}


MWRAF1 <-  read.csv("MW1 v1-Fig3a.csv", header = TRUE)
MWRAF2 <-  read.csv("MW2 v2-Fig3b.csv", header = TRUE)
MWRAF3 <-  read.csv("MW7 v7-Fig3c.csv", header = TRUE)
MWRAF4 <-  read.csv("MW8 v8-Fig3d.csv", header = TRUE)
 
Plot.Power(MWRAF1)

Plot.Power(MWRAF2)

Plot.Power(MWRAF3)

Plot.Power(MWRAF4)
 
 