library(readxl)
library(ggplot2)

#options(device=cairo_pdf)

 
getwd()
Plot.Power<-function(In.Matrix)
{
  #plot.new()
  xout<-In.Matrix[,1]
  Power.Sn<-In.Matrix[,2]
  Power.Cn<-In.Matrix[,3] 
 # Power.Dn<-In.Matrix[,4]
  Power.Vn<-In.Matrix[,4]
 
 
  #dev.off()
  
  mydat1<-data.frame(Power = Power.Sn, time= xout)
  mydat2<-data.frame(Power = Power.Cn, time= xout)
 # mydat3<-data.frame(Power = Power.Dn, time= xout)
  mydat4<-data.frame(Power = Power.Vn, time= xout)
 
  
  mydat1<-data.frame(Power.Function = Power.Sn, Pitman.Drift= xout, Power.Est = rep("Sn", dim(mydat1)[1]))
  mydat2<-data.frame(Power.Function = Power.Cn, Pitman.Drift= xout, Power.Est = rep("Cn", dim(mydat2)[1]))
  #mydat3<-data.frame(Power.Function = Power.Dn, Pitman.Drift= xout, Power.Est = rep("Dn", dim(mydat3)[1]))
  mydat4<-data.frame(Power.Function = Power.Vn, Pitman.Drift= xout, Power.Est = rep("Vn", dim(mydat4)[1]))
 
  mydat <- rbind(mydat1, mydat2,   mydat4)
 
  ggplot(data=mydat, aes(x=Pitman.Drift, y=Power.Function))+
    labs(  x = "Pitman drift", y = "Power Function")+
    geom_line(aes(color=Power.Est,  linetype=Power.Est, size=Power.Est)) +
    geom_line(data=mydat2, linetype = "dashed", color="blue") + 
   # geom_line(data=mydat3, linetype = "twodash", color="red") + 
    geom_line(data=mydat4, linetype = "longdash", color="red") +  
    scale_linetype_manual(values = c("Sn"="solid", "Cn"="dashed",   "Vn"="longdash"),
                          name="Power.Est", 
                          labels = c("Sn"="Sn", "Cn"="Cn",  "Vn"="Vn"))+ 
    scale_size_manual(values = c("Sn" = 1.1, "Cn"=1.1,   "Vn" = 1.1), 
                      name="Power.Est", 
                      labels = c("Sn"="Sn", "Cn"="Cn",   "Vn"="Vn")) +
    scale_colour_manual(values = c("Sn"="black", "Cn"="blue",   "Vn"="red"),
                        name="Power.Est", 
                        labels = c("Sn"="Sn", "Cn"="Cn",   "vn"="vn"))+ 
    theme(plot.title = element_text(lineheight=1),
          text = element_text(size=16),
          legend.title=element_blank(), #element_text(size=12),
          legend.title.align=0.5,
          legend.text = element_text(size=16),
          legend.position=c(0.98, 0.26),
          legend.justification = c(1, 1),
          legend.key.width = unit(2,'cm'),
          legend.key.height = unit(0.6, 'cm'),
          legend.box="horizontal") 
 # cairo_pdf(title, width=11.69, height=8.27) 
  #dev.off()
 #matplot(In.Matrix[,1], In.Matrix[,c(2,3,4,5,6)], type="l", lty = 1:(n-1), col=rep(1, times=n-1), lwd=rep(2, times=n-1), xlab="KL Divergence",  ylab="Power", ylim=c(0,100))
 #legend("bottomright", c(expression(S[n]),  expression(F[n]), expression(I[mn]),  expression(D[n]),  expression(V[n]) ), lty=1:(n-1), lwd=rep(2, times=n-1), col=rep(1, times=n-1), merge=TRUE, ncol=2)
}



#MWRAF1 <-  read.csv("MW.nm2Fig4a.csv")
#MWRAF2 <-  read.csv("MW.nm4Fig4b.csv")
#MWRAF3 <-  read.csv("MW.nm7Fig4c.csv")
MWRAF4 <-  read.csv("MW.nm8Fig4d.csv")
 
 



#Plot.Power(MWRAF1)
 
#Plot.Power(MWRAF2)
 
#Plot.Power(MWRAF3)
 
Plot.Power(MWRAF4)
 
 