library(nor1mix)
library(dbEmpLikeGOF)
library(kedd)
library(CvM2SL2Test)

rm(list = ls())

"kde"<-function(xin, xout, h, kfun)
{
  n<- length(xin)
  arg1<-(sapply(xout, "-", xin))/h  
  arg2<-kfun(arg1)
  arg3<-colSums(arg2)
  arg3/(n*h)
}


getPval<-function (testcall, teststat, x, y, vrb = TRUE) 
{
  if ((testcall == "normal") | (testcall == "uniform")) {
    if (testcall == "uniform") {
      testmat <- unifCut
    }
    if (testcall == "normal") {
      testmat <- normCut
    }
    smp.size <- length(x)
    coldx <- which(colnames(testmat) == smp.size)
    if (length(coldx) > 0) {
      colvls <- testmat[, coldx]
      difvls <- colvls - teststat
      absvls <- abs(difvls)
      matchVl <- which(absvls == 0)
      if (length(matchVl > 0)) {
        pvl <- as.numeric(rownames(testmat)[matchVl])
      }
      else {
        rowdx <- which(absvls == min(absvls))
        pvl <- helperPval(rowdx, colvls, teststat, testmat)
      }
    }
    else {
      if ((smp.size < 10) | (smp.size > 10000)) {
        if (smp.size < 10) {
          cat("Table generated on sample size between 10 and 10000. \n Estimating based on sample size of 10 \n For more accurate calculation use monte carlo method [pvl.Table=FALSE] \n")
          coldx <- 1
          colvls <- testmat[, coldx]
          difvls <- colvls - teststat
          absvls <- abs(difvls)
          matchVl <- which(absvls == 0)
          if (length(matchVl > 0)) {
            pvl <- as.numeric(rownames(testmat)[matchVl])
          }
          else {
            rowdx <- which(absvls == min(absvls))
            pvl <- helperPval(rowdx, colvls, teststat, 
                              testmat)
          }
        }
        else {
          cat("Table generated on sample size between 10 and 10000. \n Estimating based on sample size of 10000 \n For more accurate calculation use monte carlo method [pvl.Table=FALSE] \n")
          coldx <- 13
          colvls <- testmat[, coldx]
          difvls <- colvls - teststat
          absvls <- abs(difvls)
          matchVl <- which(absvls == 0)
          if (length(matchVl > 0)) {
            pvl <- as.numeric(rownames(testmat)[matchVl])
          }
          else {
            rowdx <- which(absvls == min(absvls))
            pvl <- helperPval(rowdx, colvls, teststat, 
                              testmat)
          }
        }
      }
      else {
        coldx1 <- max(which(as.numeric(colnames(testmat)) < 
                              smp.size))
        coldx2 <- min(which(as.numeric(colnames(testmat)) > 
                              smp.size))
        colvls <- testmat[, coldx1]
        difvls <- colvls - teststat
        absvls <- abs(difvls)
        matchVl <- which(absvls == 0)
        if (length(matchVl > 0)) {
          pvl1 <- as.numeric(rownames(testmat)[matchVl])
        }
        else {
          rowdx <- which(absvls == min(absvls))
          pvl1 <- helperPval(rowdx, colvls, teststat, 
                             testmat)
        }
        colvls <- testmat[, coldx2]
        difvls <- colvls - teststat
        absvls <- abs(difvls)
        matchVl <- which(absvls == 0)
        if (length(matchVl > 0)) {
          pvl2 <- as.numeric(rownames(testmat)[matchVl])
        }
        else {
          rowdx <- which(absvls == min(absvls))
          pvl2 <- helperPval(rowdx, colvls, teststat, 
                             testmat)
        }
        tempx <- c(as.numeric(colnames(testmat)[coldx1]), 
                   as.numeric(colnames(testmat)[coldx2]))
        tempy <- c(pvl1, pvl2)
        datamat <- as.data.frame(cbind(tempx, tempy))
        modelest <- lm("tempy~tempx", data = datamat)
        pvl <- as.numeric(modelest$coefficients[1]) + 
          (smp.size * as.numeric(modelest$coefficients[2]))
      }
    }
  }
  else {
    testmat <- distEqCut
    smp.size <- length(x)
    coldx <- which(colnames(testmat) == smp.size)
    if (length(coldx) > 0) {
      colvls <- testmat[, coldx]
      difvls <- colvls - teststat
      absvls <- abs(difvls)
      matchVl <- which(absvls == 0)
      if (length(matchVl > 0)) {
        pvlx <- as.numeric(rownames(testmat)[matchVl])
      }
      else {
        rowdx <- which(absvls == min(absvls))
        pvlx <- helperPval(rowdx, colvls, teststat, testmat)
      }
    }
    else {
      if ((smp.size < 10) | (smp.size > 500)) {
        if (smp.size < 10) {
          cat("Table generated on sample size between 10 and 500. \n Estimating based on sample size of 10 \n For more accurate calculation use monte carlo method [pvl.Table=FALSE] \n")
          coldx <- 1
          colvls <- testmat[, coldx]
          difvls <- colvls - teststat
          absvls <- abs(difvls)
          matchVl <- which(absvls == 0)
          if (length(matchVl > 0)) {
            pvl <- as.numeric(rownames(testmat)[matchVl])
          }
          else {
            rowdx <- which(absvls == min(absvls))
            pvl <- helperPval(rowdx, colvls, teststat, 
                              testmat)
          }
        }
        else {
          cat("Table generated on sample size between 10 and 500. \n Estimating based on sample size of 500 \n For more accurate calculation use monte carlo method [pvl.Table=FALSE] \n")
          coldx <- 8
          colvls <- testmat[, coldx]
          difvls <- colvls - teststat
          absvls <- abs(difvls)
          matchVl <- which(absvls == 0)
          if (length(matchVl > 0)) {
            pvl <- as.numeric(rownames(testmat)[matchVl])
          }
          else {
            rowdx <- which(absvls == min(absvls))
            pvl <- helperPval(rowdx, colvls, teststat, 
                              testmat)
          }
        }
      }
      else {
        coldx1 <- max(which(as.numeric(colnames(testmat)) < 
                              smp.size))
        coldx2 <- min(which(as.numeric(colnames(testmat)) > 
                              smp.size))
        colvls <- testmat[, coldx1]
        difvls <- colvls - teststat
        absvls <- abs(difvls)
        matchVl <- which(absvls == 0)
        if (length(matchVl > 0)) {
          pvl1 <- as.numeric(rownames(testmat)[matchVl])
        }
        else {
          rowdx <- which(absvls == min(absvls))
          pvl1 <- helperPval(rowdx, colvls, teststat, 
                             testmat)
        }
        colvls <- testmat[, coldx2]
        difvls <- colvls - teststat
        absvls <- abs(difvls)
        matchVl <- which(absvls == 0)
        if (length(matchVl > 0)) {
          pvl2 <- as.numeric(rownames(testmat)[matchVl])
        }
        else {
          rowdx <- which(absvls == min(absvls))
          pvl2 <- helperPval(rowdx, colvls, teststat, 
                             testmat)
        }
        tempx <- c(as.numeric(colnames(testmat)[coldx1]), 
                   as.numeric(colnames(testmat)[coldx2]))
        tempy <- c(pvl1, pvl2)
        datamat <- as.data.frame(cbind(tempx, tempy))
        modelest <- lm("tempy~tempx", data = datamat)
        pvlx <- as.numeric(modelest$coefficients[1]) + 
          (smp.size * as.numeric(modelest$coefficients[2]))
      }
    }
    if (length(y) == length(x)) {
      pvl = pvlx
    }
    else {
      smp.size <- length(y)
      coldx <- which(colnames(testmat) == smp.size)
      if (length(coldx) > 0) {
        colvls <- testmat[, coldx]
        difvls <- colvls - teststat
        absvls <- abs(difvls)
        matchVl <- which(absvls == 0)
        if (length(matchVl > 0)) {
          pvly <- as.numeric(rownames(testmat)[matchVl])
        }
        else {
          rowdx <- which(absvls == min(absvls))
          pvly <- helperPval(rowdx, colvls, teststat, 
                             testmat)
        }
      }
      else {
        if ((smp.size < 10) | (smp.size > 500)) {
          if (smp.size < 10) {
            cat("Table generated on sample size between 10 and 500. \n Estimating based on sample size of 10 \n For more accurate calculation use monte carlo method [pvl.Table=FALSE] \n")
            coldx <- 1
            colvls <- testmat[, coldx]
            difvls <- colvls - teststat
            absvls <- abs(difvls)
            matchVl <- which(absvls == 0)
            if (length(matchVl > 0)) {
              pvl <- as.numeric(rownames(testmat)[matchVl])
            }
            else {
              rowdx <- which(absvls == min(absvls))
              pvl <- helperPval(rowdx, colvls, teststat, 
                                testmat)
            }
          }
          else {
            cat("Table generated on sample size between 10 and 500. \n Estimating based on sample size of 500 \n For more accurate calculation use monte carlo method [pvl.Table=FALSE] \n")
            coldx <- 8
            colvls <- testmat[, coldx]
            difvls <- colvls - teststat
            absvls <- abs(difvls)
            matchVl <- which(absvls == 0)
            if (length(matchVl > 0)) {
              pvl <- as.numeric(rownames(testmat)[matchVl])
            }
            else {
              rowdx <- which(absvls == min(absvls))
              pvl <- helperPval(rowdx, colvls, teststat, 
                                testmat)
            }
          }
        }
        else {
          coldx1 <- max(which(as.numeric(colnames(testmat)) < 
                                smp.size))
          coldx2 <- min(which(as.numeric(colnames(testmat)) > 
                                smp.size))
          colvls <- testmat[, coldx1]
          difvls <- colvls - teststat
          absvls <- abs(difvls)
          matchVl <- which(absvls == 0)
          if (length(matchVl > 0)) {
            pvl1 <- as.numeric(rownames(testmat)[matchVl])
          }
          else {
            rowdx <- which(absvls == min(absvls))
            pvl1 <- helperPval(rowdx, colvls, teststat, 
                               testmat)
          }
          colvls <- testmat[, coldx2]
          difvls <- colvls - teststat
          absvls <- abs(difvls)
          matchVl <- which(absvls == 0)
          if (length(matchVl > 0)) {
            pvl2 <- as.numeric(rownames(testmat)[matchVl])
          }
          else {
            rowdx <- which(absvls == min(absvls))
            pvl2 <- helperPval(rowdx, colvls, teststat, 
                               testmat)
          }
          tempx <- c(as.numeric(colnames(testmat)[coldx1]), 
                     as.numeric(colnames(testmat)[coldx2]))
          tempy <- c(pvl1, pvl2)
          datamat <- as.data.frame(cbind(tempx, tempy))
          modelest <- lm("tempy~tempx", data = datamat)
          pvly <- as.numeric(modelest$coefficients[1]) + 
            (smp.size * as.numeric(modelest$coefficients[2]))
        }
      }
      pvl <- mean(c(pvlx, pvly))
    }
  }
  return(pvl)
}


dbEmpLikeGOF<-function (x, y = NA, testcall = c("uniform", "normal"), delta = 0.5, 
                        delta.equality = 0.1, num.mc = 1000, pvl.Table = TRUE, vrb = TRUE, 
                        random.seed.flag = TRUE) 
{
  if (is.na(y[1])) {
    if ((testcall != "uniform") & (testcall != "normal")) {
      stop("testcall not appropriately defined in function call \n  testcall should be either 'uniform' or 'normal' \n")
    }
    else {
      nx <- length(x)
      if (testcall == "uniform") {
        if (vrb) 
          n <- length(x)
        x.o <- sort(x)
        m <- 1:n^(1 - delta)
        tomin <- mapply(FUN = "testfun", m = m, MoreArgs = list(x.o = x.o, 
                                                                n = n))
        logTomin <- log(tomin)
        sumTomin <- apply(FUN = "sum", MARGIN = 2, logTomin)
        teststat <- min(sumTomin)
        if (pvl.Table) {
          if (delta != 0.5) 
            cat("Table calculated on a delta = 0.5 \n    To use delta=", 
                delta, " please change pvl.Table to FALSE \n")
          pvl <- getPval(testcall, teststat, x, y, vrb)
        }
        else {
          if (vrb) 
            mc.est <- c()
          for (j in 1:num.mc) {
            if (random.seed.flag) {
              set.seed(j)
            }
            x <- runif(nx)
            x.o <- sort(x)
            m <- 1:nx^(1 - delta)
            tomin <- mapply(FUN = "testfun", m = m, MoreArgs = list(x.o = x.o, 
                                                                    n = nx))
            logTomin <- log(tomin)
            sumTomin <- apply(FUN = "sum", MARGIN = 2, 
                              logTomin)
            mc.est[j] <- min(sumTomin)
          }
          estp.rh <- sum(mc.est > teststat)/num.mc
          pvl <- estp.rh
        }
        output <- list(teststat = teststat, pvalue = pvl)
      }
      else {
        if (vrb) 
          n <- length(x)
        m1 <- 1:round(n/2)
        m2 <- 1:n^(1 - delta)
        x.o <- sort(x)
        VN2 <- mapply(FUN = "testfun", m = m2, MoreArgs = list(x.o = x.o, 
                                                               n = n))
        logVN2 <- log(VN2)
        sumVN2 <- apply(FUN = "sum", MARGIN = 2, logVN2)
        teststat <- min((((n/2) * log(2 * pi * exp(1) * 
                                        var(x))) + sumVN2))
        if (pvl.Table) {
          if (delta != 0.5) 
            cat("Table calculated on a delta = 0.5 \n    To use delta=", 
                delta, " please change pvl.Table to FALSE \n")
          pvl <- getPval(testcall, teststat, x, y, vrb)
        }
        else {
          if (vrb) 
            mc.estVN2 <- c()
          for (j in 1:num.mc) {
            if (random.seed.flag) {
              set.seed(j)
            }
            x <- rnorm(nx)
            m2 <- 1:nx^(1 - delta)
            x.o <- sort(x)
            VN2 <- mapply(FUN = "testfun", m = m2, MoreArgs = list(x.o = x.o, 
                                                                   n = nx))
            logVN2 <- log(VN2)
            sumVN2 <- apply(FUN = "sum", MARGIN = 2, 
                            logVN2)
            mc.estVN2[j] <- min((((n/2) * log(2 * pi * 
                                                exp(1) * var(x))) + sumVN2))
          }
          estp.rh <- sum(mc.estVN2 > teststat)/num.mc
          pvl <- estp.rh
        }
        output <- list(teststat = teststat, pvalue = pvl)
      }
    }
  }
  else {
    if ((delta.equality > 0.25) & (delta.equality < 0)) 
      stop("delta.equality must be between 0.0 and 0.25")
    testcall <- "distribution.equality"
    if (vrb) 
      n1 <- length(x)
    n2 <- length(y)
    l1 <- floor(n1^(0.5 + delta.equality))
    u1 <- ceiling(min((n1^(1 - delta.equality)), (n1/2)))
    mvc <- seq(l1, u1, by = 1)
    j1 <- 1:n1
    i <- 1
    tomin1 <- mapply(FUN = "testfun5", m = mvc, MoreArgs = list(x = x, 
                                                                y = y, i = i, j = j1))
    ans.pt1 <- min(tomin1)
    l2 <- floor(n2^(0.5 + delta.equality))
    u2 <- ceiling(min((n2^(1 - delta.equality)), (n2/2)))
    vvc <- seq(l2, u2, by = 1)
    j2 <- 1:n2
    i <- 2
    tomin2 <- mapply(FUN = "testfun5", m = vvc, MoreArgs = list(x = x, 
                                                                y = y, i = i, j = j2))
    ans.pt2 <- min(tomin2)
    teststat <- log((ans.pt1 * ans.pt2))
    if (pvl.Table) {
      if (delta.equality != 0.1) 
        cat("Table calculated on a delta = 0.1 \n    To use delta.equality=", 
            delta.equality, " please change pvl.Table to FALSE \n")
      pvl <- getPval(testcall, teststat, x, y, vrb)
    }
    else {
      if (vrb) 
        toMinpvec <- c()
      for (j in 1:num.mc) {
        if (random.seed.flag) {
          set.seed(j)
        }
        v1 <- rnorm(n1, mean = 0, sd = 1)
        if (random.seed.flag) {
          set.seed(j + 1)
        }
        v2 <- rnorm(n2, mean = 0, sd = 1)
        l1 <- floor(n1^(0.5 + delta.equality))
        u1 <- ceiling(min((n1^(1 - delta.equality)), 
                          (n1/2)))
        mvc <- seq(l1, u1, by = 1)
        j1 <- 1:n1
        i <- 1
        tomin1 <- mapply(FUN = "testfun5", m = mvc, MoreArgs = list(x = v1, 
                                                                    y = v2, i = i, j = j1))
        ans.pt1 <- min(tomin1)
        l2 <- floor(n2^(0.5 + delta.equality))
        u2 <- ceiling(min((n2^(1 - delta.equality)), 
                          (n2/2)))
        vvc <- seq(l2, u2, by = 1)
        j2 <- 1:n2
        i <- 2
        tomin2 <- mapply(FUN = "testfun5", m = vvc, MoreArgs = list(x = v1, 
                                                                    y = v2, i = i, j = j2))
        ans.pt2 <- min(tomin2)
        toMinpvec[j] <- log((ans.pt1 * ans.pt2))
      }
      estp.rh <- sum(toMinpvec > teststat)/num.mc
      pvl <- estp.rh
    }
    output <- list(teststat = teststat, pvalue = pvl)
  }
  return(output)
}

options(show.error.messages = FALSE)

kgaussian<-function(x)
{
  result <- 0.3989 * exp(-0.5*x*x)
  result
}

kunif<-function(x, h){
  ifelse(x==0, 0, ifelse(abs(x)<h, 1, 0))
}

kunif<- function(x) { ifelse(abs(x)< 2.236068, (3/4)*(1-((x^2)/5 ))/2.236068, ifelse(abs(x)>2.236068, 0,0)) }


NormMixtProb<-function(x, n, p1)
{
  piuse1 <- pnorMix(x[1:(n+1)], p1) # calculate the pi's under the null
  piuse2 <- pnorMix(x[2:(n+2)], p1)
  piuse<- piuse2 - piuse1 #  p_j=\int_{I_i} f_0(x) dx = F_0(x_{i+1})-F_0(x_i)
  piusen<- 1-pnorMix(x[n+2], p1) # probbaility of the last (half) interval
  
  piuse<-c( piuse, piusen)
  piuse
}

NDistDens<-function(x, dist, p1, p2)
{
  switch(dist, 
         normixt = dnorMix(x,  p1), 
         exponential = dexp(x, p1),
         lnorm = dlnorm(x,  p1, p2), 
         weibull = dweibull(x, p1, p2),
         normal = dnorm(x, p1, p2)
  )
}



DataDistribution<-function(SampleSize, Datadist,  s1, s2)
{
  switch(Datadist, 
         normixt = rnorMix(SampleSize, s1), 
         exponential = rexp(SampleSize, rate=s1),
         lnorm = rlnorm(SampleSize, meanlog=s1, sdlog = s2), 
         weibull = rweibull(SampleSize, s1, s2),
         normal = rnorm(SampleSize, s1, s2))
}




hopt.be<-function(xin)
{
  n<-length(xin)
  h<-bw.nrd(xin) #pilot bandwidth for the kernel estimate
  DensityEst <- kde(xin,xin, h, kgaussian)
  Rhatfx <- mean(DensityEst) #estimate R(f)
  Rhatfxthird <- mean(DensityEst^3) #estimate R(f)
  banduse<- (1/sqrt(n))*sqrt((Rhatfx * 0.2571)/(Rhatfxthird * 0.345)) #based on the epanechnikov kernel
  banduse
}


T.n2<-function(xin, h, dist, p1, p2)
  #xin: the random sample
  # h: the bandwidth to use in the test statistic - also conider the very first MSE optimal rule
  # dist: distribution under the null
  # p1: 1st parameter of the distribution dist. In case of Normal Mixtures this is the object MW.nm7 etc
  # p2: 2nd parameter of the distribution dist.
{
  MinX<-min(xin)
  MaxX<-max(xin)
  N<-length(xin)
  
  Delta<-sd(xin)/N^{3/4} #n is the number of bins - set by A1.
  n<- ceiling( (MaxX - MinX)/Delta ) # Assumption A1: Delta ~ N^{-a}, 1/2<a<1, set a=3/4.  
  
  PartInt<-c(MinX, MinX+(1:n)*Delta) #Partion the interval (x[1], x[n]) into subintervals
  BinCenters<-( PartInt[1:n] + PartInt[2:(n+1)])/2 # calculate the Bincenters:
  yi <- sapply(1:n, function(i, xin, PartInt) length(which(xin >= PartInt[i] & xin < PartInt[i+1])), xin, PartInt)/(N*Delta) #scaled bin counts as p.d.f. estimates
  arg1<-(sapply(BinCenters, "-", BinCenters))  # cross product of all BinCenters in order to calculate K{(x_i - x_j)/h}
  Null.Dens.Est<- NDistDens(BinCenters, dist,   p1, p2)  
  
  Dens.Diffs<- yi-Null.Dens.Est  # Yi - f(x_i) 
  All.Dens.Diffs<- Dens.Diffs %*% t(Dens.Diffs)  # cross product of all Yi - f(x_i) diffs
  arg2<-kunif(arg1/h) #h
  test.stat.tmp<-arg2 * All.Dens.Diffs 
  
  test.statistic<-  sum(test.stat.tmp) #N*sqrt(h)* sum(test.stat.tmp)/h  # N*\sqrt(h)*sum(test.stat.tmp)/(g*(g-1)*h)
  c(test.statistic,  Delta)
}

PowerGraphs<-function(SampleSize,    Datadist,  p1, p2, altparam, h, a.sig)
{
  nn<-length(altparam)
  TBDmatrix<-matrix(0, nrow=nn, ncol=5)  
  for(i in 1:nn)
  {
    PowerMat<-matrix(0,nrow=100, ncol=ncol(TBDmatrix)-1)
    for(j in 1:100)
    {
      x1<-  c(rnorm(8,  altparam[i], 1), rnorm(8, 1/2+altparam[i], 2/3), rnorm(24, 13/12+altparam[i], 5/9)) 
      y1<- DataDistribution(SampleSize, Datadist,  p1, p2)  
      
      theta.hat<- norMixMLE(c(x1,y1), 3, trace=-1) 
      ex2 <- norMix(name = "ex2",
                    mu = theta.hat[,1],
                    sigma = theta.hat[,2],
                    w = theta.hat[,3])
      
      z1<-rnorMix(SampleSize, ex2)
      
      ex2alt <- norMix(name = "ex2alt",
                       mu = theta.hat[,1]+altparam[i],
                       sigma = theta.hat[,2],
                       w = theta.hat[,3])
      
      z2 <- rnorMix(SampleSize, ex2alt)
      
      hx<-     hopt.be(z1) *0.9    # bw.nrd(x1) #
      hy<-      hopt.be(z2) *0.9     # bw.nrd(x1) #
      #h1<-bw.SJ(z1) #bw.nrd(x1) #
      DensityEstx <- dnorMix(z1, ex2) #kde(z1,z1, h1, kgaussian)
      nu2x <- mean(DensityEstx)
      
      #h2<-bw.SJ(z2) #bw.nrd(y1) #
      DensityEsty <- dnorMix(z2, ex2alt) # kde(z2,z2, h2, kgaussian)
      nu2y <- mean(DensityEsty)
      
      T.n2x.x <-T.n2(z1, hx, Datadist, ex2, p2)
      T.n2y.y <- T.n2(z2, hy, Datadist, ex2, p2)
      T.n2x<- T.n2x.x[1]  
      T.n2y<- T.n2y.y[1] 
      t1<-( 2*SampleSize^{-2}* 3/5 *hx * nu2x)/T.n2x.x[2]^4
      t2<- ( 2*SampleSize^{-2}* 3/5 * hy * nu2y)/T.n2y.y[2]^4
      
      T.n<- (T.n2x/t1 + T.n2y/t2) / sqrt( 1/t1 + 1/t2 )
      CvM<-  cvmts.test(z1, z2)   #USE AS INPUT DATA FROM THE  DISTRIBUTIONS (NULL AND ALTERNATIVE) USING THE mle PARAMETER ESTIMATES
      Dntest <- ks.test(z1, z2)$p.value  
      LGoFtest <- dbEmpLikeGOF(z1, z2)$pvalue # InVn.list$pvalue
      
      PowerMat[j,]<- c(T.n, CvM, Dntest,   LGoFtest) #store the test statistic values
    }	
    aps<-PowerMat[,1]
    CvMps<- cvmts.pval(PowerMat[,2], 40, 40) 
    Dntest<-PowerMat[,3]
    LGoFtestps<-PowerMat[,4]
    
    Tn.pow <-length(which(aps > 1.64) ) 
    CvMPower<-length(which(CvMps < a.sig))
    DntestPower<-length(which(Dntest < a.sig))
    LGoFtestPower<- length(which(LGoFtestps < a.sig))
    
    TBDmatrix[i,]<-c(altparam[i], Tn.pow, CvMPower, DntestPower,   LGoFtestPower)	
  }
  colnames(TBDmatrix)<-c("Drift", "Sn",   "Cn", "Dn",   "Vn")
  TBDmatrix
}

Power.Simulation<-function(NIter, SampleSize, h, Datadist,   p1, p2,altparam, a.sig)
{
  AllResults<-list(NIter)
  TestNames<-  c("Sn", "Cn", "Dn",  "Vn")
  TestNames1<- c(expression(S[n]), expression(C[n]), expression(D[n]) ,    expression(V[n]))
  for(i in 1:NIter)
  {
    cat("i= ", i, "\n")
    AllResults[[i]]<-PowerGraphs(SampleSize,  Datadist,  p1, p2, altparam, h, a.sig)
    prmatrix(AllResults[[i]])
  }
  Result.Out<- Reduce("+", AllResults)/NIter # return average of NIter iterations
  Plot.Power(Result.Out, TestNames1, altparam)
  colnames(Result.Out)<-c("Pitman Drift", "Sn", "Cn", "Dn", "Vn")
  Result.Out
}

Plot.Power<-function(In.Matrix, TestNames1, altparam)
{
  n<-ncol(In.Matrix)
  matplot(In.Matrix[,1], In.Matrix[,2:n], type="l", lty = 1:(n-1), col=rep(1, times=n-1), xlab="Pitman Drift",    ylab="Power", ylim=c(0,100))
  legend("bottomright", c(expression(S[n]),   expression(C[n]), expression(D[n]), expression(V[n])), lty=1:(n-1), col=rep(1, times=n-1), merge=TRUE, ncol=2)
}


set.seed(3)

a.sig<-0.05
SampleSize<-40
Number.Iter<-60

Nulldist<-"normixt"

NullDistParam1<- MW.nm2 
NullDistParam2<-1


AltDistParam <-    seq(0, 1, by=0.05)#, by=0.2
mya<-  Power.Simulation(Number.Iter, SampleSize, h,  Nulldist,  NullDistParam1, NullDistParam2, AltDistParam, a.sig) 
write.csv(mya, file=paste(deparse(substitute(MW.nm2)), "1.csv"))

mya
